Public Class BMICalculator
    Private mdblHeight As Double
    Private mdblWeight As Double
    Private mdblBMI As Double
    Private mstrBMIRating As String


    Public Property Height() As Double
        Get
            Return mdblHeight
        End Get
        Set(ByVal Value As Double)
            mdblHeight = Value
        End Set
    End Property

    Public Property Weight() As Double
        Get
            Return mdblWeight
        End Get
        Set(ByVal Value As Double)
            mdblWeight = Value
        End Set
    End Property

    Public ReadOnly Property MBI() As Double
        Get
            Return mdblBMI
        End Get
    End Property

    Public ReadOnly Property BMIRating() As String
        Get
            Return mstrBMIRating
        End Get
    End Property

    Public Sub New(ByVal dblHeight As Double, ByVal dblWeight As Double)
        Height = dblHeight
        Weight = dblWeight
        calculateBMI()
        getRating()
    End Sub
    Private Sub calculateBMI()
        Const intBMI_FACTOR As Integer = 703I 'Look on page 100 for other Type Declaration characters
        Dim dblBMI As Double = mdblWeight / mdblHeight / mdblHeight * intBMI_FACTOR
        mdblBMI = dblBMI
    End Sub

    Private Sub getRating()
        If Not (mdblBMI > 0 And mdblBMI < 100) Then
            Throw New InvalidConstraintException("ERROR:001 - BMI cannot be less or equal to zero. Please check your values.")
        End If
        'Calculate the BMI rating based on the following criteria:
        '   BMI is less than 19, you are Underweight
        '   BMI is between 19 and 25, you are Normal
        '   BMI is between 15 and 30, you are Overweight
        '   BMI is over 30, you are Obese

        Dim strRatingCategories(,) As String = {{"0", "Underweight"}, _
                                                {"19", "Normal"}, _
                                                {"25", "Overweight"}, _
                                                {"30", "Obese"}}

        Dim index As Integer
        For index = strRatingCategories.GetLength(0) - 1 To 0 Step -1
            If mdblBMI > CInt(strRatingCategories(index, 0)) Then
                Exit For
            End If
        Next

        Me.mstrBMIRating = strRatingCategories(index, 1)
    End Sub
End Class
